// Emacs will be in -*- Mode: c++ -*-
#ifndef _error_h
#define _error_h    

// C++ includes
#include <iostream.h>
#include <string>

using std::string;
          
//! Exception class for errors.
class Error
{
private:
  //! string of error message
  const char *mesg_;
public:
  //! constructor with const char * argument
  Error(const char *m) : mesg_(m) { message(); }
  //! constructor with string argument
  Error(const string& str) : mesg_(str.c_str()) { message(); }
  
  //! virtual method to display error message
  virtual void message() { cerr << mesg_ << endl;}
  //! virtual method to display type of error
  virtual string type() { return string("Basic Error"); }
};
     
#endif
